#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>

#pragma GCC optimize("O3")
#pragma GCC target("avx2")

using namespace std;
using namespace __gnu_pbds;

#define int long long



signed main() {
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n, m, t;
    cin >> n >> m >> t;
    vector<int> a(n + 1), pr(n + 1);
    for (int i = 1; i <= n; i++) {
        cin >> a[i];
        pr[i] = pr[i - 1] + a[i];
    }
    vector<int> b(m);
    for (int i = 0; i < m; i++) {
        cin >> b[i];
    }
    int mx = 0;
    for (int i = 1; i <= m; i++) {
        mx = max(mx, t / a[i]);
    }
    cout << mx;
}
